﻿using System;
namespace myBlazorApp.Components;

using Blazorise;
using Microsoft.AspNetCore.Components;
using myBlazorApp.Models;

public partial class InventoryItem
{
    [Parameter]
    public Item Item { get; set; }
    [Parameter]
    public int Index { get; set; }
    [CascadingParameter]
    public MyInventory Parent { get; set; }

    internal void OnDragEnter()
    {

        Parent.Actions.Add(new InventoryAction { Action = "Drag Enter", Item = this.Item, Index = this.Index });
    }

    internal void OnDragLeave()
    {

        Parent.Actions.Add(new InventoryAction { Action = "Drag Leave", Item = this.Item, Index = this.Index });
    }

    internal void OnDrop()
    {
        this.Item = Parent.CurrentDragItem;

        Parent.Actions.Add(new InventoryAction { Action = "Drop", Item = this.Item, Index = this.Index });

    }

    private void OnDragStart()
    {
        Parent.CurrentDragItem = this.Item;

        Parent.Actions.Add(new InventoryAction { Action = "Drag Start", Item = this.Item, Index = this.Index });
    }
}

