﻿using System;
using System.Collections.ObjectModel;
using System.Collections.Specialized;
using Microsoft.AspNetCore.Components;
using Microsoft.JSInterop;
using myBlazorApp.Models;
using myBlazorApp.Services;
namespace myBlazorApp.Components
{
    public partial class MyInventory
    {
        [Parameter]
        public List<Item> ItemsInventory { get; set; } = new List<Item>();
        public ObservableCollection<InventoryAction> Actions { get; set; }
        public Item CurrentDragItem { get; set; }
        [Parameter]
        public int index { get; set; } = 0;

        public MyInventory()
        {
            Actions = new ObservableCollection<InventoryAction>();
            Actions.CollectionChanged += OnActionsCollectionChanged;
        }

        [Inject]
        public IDataService DataService { get; set; }

        [Inject]
        public IWebHostEnvironment WebHostEnvironment { get; set; }

        [Inject]
        public NavigationManager NavigationManager { get; set; }

        [Inject]
        internal IJSRuntime JavaScriptRuntime { get; set; }

        /*
        protected override async Task OnAfterRenderAsync(bool firstRender)
        {
            base.OnAfterRenderAsync(firstRender);

            if (!firstRender)
            {
                return;
            }
            itemsInventory = await DataService.List(0, await DataService.Count());
            StateHasChanged();
        }
        */

        private void OnActionsCollectionChanged(object? sender, NotifyCollectionChangedEventArgs e)
        {
            JavaScriptRuntime.InvokeVoidAsync("MyInventory.AddActions", e.NewItems);
        }
    }
}

